// About
if (typeof textsAuthors === 'undefined') {
    textsAuthors=
    [
        // align: [desktop, mobile], 0 = left, 1 = right
        {
            "id": "alca",
            "name": "Alena Plzáková",
            "img": "/img/h_alca.jpg",
            "align": [0, 0],
            "position": {
                "en-GB": "Product manager & designer (product developer), Albi ČR",
                "cs": "Product manager & designer (product developer), Albi ČR"
            },
            "text": {
                "en-GB": "Enthusiastic about developing products for children, overcoming challenges, finding solutions, prototyping, 3D printing and crafts. Lover of plants, gardens and her family.",
                "cs": "Nadšenec pro vývoj produktů pro děti. Baví ji zdolávání výzev a hledání nových řešení, rapid prototyping, 3D tisk a řemesla. Jejími největšími koníčky jsou rodina, zahrada a rostliny všeho druhu."
            }
        },
        {
            "id": "jirka",
            "name": "Jiří Trojánek",
            "img": "/img/h_jirka.jpg",
            "align": [0, 0],
            "position": {
                "en-GB": "Designer & Photographer",
                "cs": "Designer & Fotograf"
            },
            "text": {
                "en-GB": "A former photographer of Zoo Prague, now a graphic designer and creative professional. A happy father, lover of music, good food, drinks, culture and friends. Also a collector of vinyl records, art, books about art and architecture.",
                "cs": "Bývalý fotograf Zoo Praha, nyní grafik a kreativní profesionál. Šťastný otec, milovník hudby, dobrého jídla, pití, kultury a přátel. Také sběratel vinylových desek, umění, knih o umění a architektuře."
            }
        },
        {
            "id": "vitek",
            "name": "Vít Latzel",
            "img": "/img/h_vitek.jpg",
            "align": [0, 0],
            "position": {
                "en-GB": "Scientist, Deputy director, Botanický ústav AV ČR, v. v. i. (Institute of Botany)",
                "cs": "Vědec, zástupce ředitele, Botanický ústav AV ČR, v. v. i."
            },
            "text": {
                "en-GB": "He is interested in the environmental consequences of epigenetic memory in plants. In his spare time, he likes to spend time with his family, in nature, reading, following technological innovations and taking pictures of all kinds of things.",
                "cs": "Zabývá se ekologickými důsledky epigenetické paměti u rostlin. Ve volném čase tráví nejraději čas s rodinou, v přírodě, čtením, sledováním technologických novinek a focením všeho možného."
            }
        },
        {
            "id": "ondra",
            "name": "Ondřej Nentvich",
            "img": "/img/h_ondra.jpg",
            "align": [1, 0],
            "position": {
                "en-GB": "HW & FW Designer, Freelancer",
                "cs": "HW & FW Designer, Freelancer"
            },
            "text": {
                "en-GB": "Enthusiast in the Embedded electronics and IoT systems, their development, programming and testing. Likes new challenges in this field and exploring new possibilities and capabilities in this branch. Outside of work, he enjoys the outdoors whether on foot, bike or motorcycle, amateur photography or playing baker.",
                "cs": "Fanoušek vestavěné elektroniky a IoT systémů. Baví ho nové výzvy v tomto oboru, stejně jako zkoumání jeho možností a schopností. Mimo pracovní nasazení rád tráví čas v přírodě, ať pěšky, na kole nebo na motorce, zároveň se věnuje amatérské fotografii a občas si zahraje na pekaře."
            }
        },
        {
            "id": "mira",
            "name": "Mira Veselá",
            "img": "/img/h_mira.jpg",
            "align": [1, 0],
            "position": {
                "en-GB": "Designer, Freelancer",
                "cs": "Designer, Freelancer"
            },
            "text": {
                "en-GB": "She focuses mainly on product design and projects with interdisciplinary overlap, where there is room for finding creative solutions. She balances digital creation with working with real materials – textiles and plant pigments. In general, she is very interested in alternative materials and circularity in design. Her hobbies include dancing, hiking and bike-packing.",
                "cs": "Věnuje se zejména produktovému designu a projektům s mezioborovým přesahem, kde je prostor pro hledání kreativních řešení. Digitální tvorbu vyvažuje prací se skutečným materiálem - textilem a rostlinnými pigmenty. Obecně ji hodně zajímají alternativní materiály a cirkularita v designu. Jejími koníčky jsou koníčky tanec, pěší výlety a bikepacking."
            }
        },
        {
            "id": "albilab",
            "name": "AlbiLAB Team",
            "img": "/img/AlbiLAB.jpg",
            "position": {
                "en-GB": "",
                "cs": ""
            },
            "align": [1, 0],
            "text": {
                "en-GB": "",
                "cs": ""
            }
        }
    ];
}
    // load about
var mobile = 0;

if (/Mobi|Android/i.test(navigator.userAgent)) {
	mobile = 1;
}

function loadAbout() {
    if (typeof textsAuthors === 'undefined') {
        loadScriptsSequentially(scripts, 0);
        setTimeout(loadAbout, 100); // Retry after a delay
        return;
    }
    for (var i = 0; i < textsAuthors.length; i++) {
        var author = textsAuthors[i];
        var authorID = "author_" + author["id"];
        var element = document.getElementById(authorID);

        if(element !== null){
            var align = author["align"][mobile];
            var position = author["position"][currentLanguage]; // Change this to "cs" for Czech language
            var text = author["text"][currentLanguage]; // Change this to "cs" for Czech language
            if(align === 1){
                element.innerHTML = 
                '<h1 class="about_header">' + author["name"] + '</h1>' +
                '<div class="about_row">' + 
                    '<div class="about_text"><i>' + position + '</i><br/>' + text + '</div>' + 
                    '<div class="about_photo"><img class="about_photo_img" data-src="' + author["img"] + '"/></div>'+ 
                '</div>';
            }
            else{
                element.innerHTML = 
                '<h1 class="about_header">' + author["name"] + '</h1>' +
                '<div class="about_row">' + 
                    '<div class="about_photo"><img class="about_photo_img" data-src="' + author["img"] + '"/></div>'+ 
                    '<div class="about_text"><i>' + position + '</i><br/>' + text + '</div>' + 
                '</div>';
            }
            continue;
        }

        element = document.getElementById("about_albilab");
        if(element !== null){
                element.innerHTML = 
                '<h1 class="about_header">' + author["name"] + '</h1>' +
                '<div style="margin: 20px;"><img class="about_photo_img" data-src="' + author["img"] + '"/></div>'+ 
                '<div class="about_text" style="padding-top: 50px;">' + author["text"][currentLanguage] + '</div>' ;
        }
    }

    var images = document.querySelectorAll('.about_photo_img');
	var lastLoadIndex = 0;
	var loadNextImage = function () {
		if (images.length === lastLoadIndex) {
			return;
		}
		images[lastLoadIndex].src = images[lastLoadIndex].getAttribute('data-src');
		lastLoadIndex += 1;
	};
	images.forEach(function (img) {
		img.addEventListener('load', loadNextImage);
	});
	loadNextImage();
}

loadAbout();